package kontakty;

import java.text.Collator;
import java.util.ArrayList;
import java.util.List;
import java.util.stream.Collectors;

public class Program 
{
    private static ArrayList<Kontakt> kontakty = new ArrayList<>();
    
    private static void příprava()
    {
        kontakty.add(new Kontakt("Jana Vopršálková", "soukromý", "1234546789"));
        kontakty.add(new Kontakt("Jiří Novotný", "pracovní", "2345467890"));
        kontakty.add(new Kontakt("Alexandr Motyčka", "soukromý", "321654987"));
        kontakty.add(new Kontakt("Ivo Nádvorník", "pracovní", "147258369"));
        kontakty.add(new Kontakt("Alena Jirků", "pracovní", "951628473"));
        kontakty.add(new Kontakt("Ivo Nádvorník", "soukromý", "547852364"));
        kontakty.add(new Kontakt("Honza Nový", "soukromý", "987852364"));
        kontakty.add(new Kontakt("Chechták Jarský", "soukromý", "357852364"));
        
    }
    
    private static void výpisVšechKontaktů()
    {
        kontakty.stream().forEachOrdered(k->System.out.println(k));
    }
    
    private static void upravSoukroméKontakty()
    {
        kontakty.stream().filter(k->k.typ.equals("soukromý")).forEach(k->k.telefon = "S" + k.telefon);
    }
    
    private static void vypišSeřazenáJména()
    {
        kontakty.stream().map(kontakt -> kontakt.jméno)
                .distinct().sorted()
                .forEachOrdered(jméno->System.out.println(jméno));
    }
    
    private static void vypišSeřazenáJménaPodruhé()
    {
        kontakty.stream().map(kontakt -> kontakt.jméno)
                .distinct().sorted(Collator.getInstance())
                .forEachOrdered(jméno->System.out.println(jméno));
    }
    
    private static void vypišObráceneSeřazenáJména()
    {
        kontakty.stream().map(kontakt->kontakt.jméno)
                .distinct()
                .sorted(Collator.getInstance().reversed())
                .forEachOrdered(jméno->System.out.println(jméno));
    }
    
    public static String[] kontaktyJakoPole()
    {
        return kontakty.stream().map(kontakt->kontakt.jméno)
                .distinct().toArray(String[]::new);
    }
    
    public static String kontaktyJakoŘetězec()
    {
        return kontakty.stream().map(kontakt -> kontakt.jméno + ", ").distinct()
                .collect(StringBuilder::new, StringBuilder::append, StringBuilder::append).toString();
    }
    
    public static List<String> převodDatovoduNaKolekci()
    {
        return kontakty.stream().map(kontakt -> kontakt.jméno + ", ").distinct()
                .collect(Collectors.toList());
    }
    public static void main(String[] args) 
    {
        příprava();
        /*výpisVšechKontaktů();
        System.out.println("------------");
        upravSoukroméKontakty();
        výpisVšechKontaktů();*/
        //vypišSeřazenáJména();
        //vypišObráceneSeřazenáJména();
        //vypišSeřazenáJménaPodruhé();
//        var pole = kontaktyJakoPole();
//        for(var jméno : pole)
//        {
//            System.out.println(jméno);
//        }
          System.out.println(kontaktyJakoŘetězec());
    }
    
}
